 .../am263x-cc/r5fss0-0_freertos/example.syscfg               |  6 +++---
 .../dpl/interrupt_prioritization/interrupt_prioritization.c  | 12 ++++++++++++
 2 files changed, 15 insertions(+), 3 deletions(-)

diff --git a/examples/kernel/dpl/interrupt_prioritization/am263x-cc/r5fss0-0_freertos/example.syscfg b/examples/kernel/dpl/interrupt_prioritization/am263x-cc/r5fss0-0_freertos/example.syscfg
index 0946fe00bb..935fe6fc24 100644
--- a/examples/kernel/dpl/interrupt_prioritization/am263x-cc/r5fss0-0_freertos/example.syscfg
+++ b/examples/kernel/dpl/interrupt_prioritization/am263x-cc/r5fss0-0_freertos/example.syscfg
@@ -2,7 +2,7 @@
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
  * @cliArgs --device "AM263x_beta" --package "ZCZ" --part "AM263x" --context "r5fss0-0" --product "MCU_PLUS_SDK@07.03.01"
- * @versions {"tool":"1.10.0+2163"}
+ * @versions {"tool":"1.14.0+2667"}
  */
 
 /**
@@ -49,17 +49,17 @@ mpu_armv74.size              = 21;
 
 timer1.$name         = "CONFIG_TIMER0";
 timer1.timerCallback = "timer0_ISR";
-timer1.intrPriority  = 2;
 timer1.usecPerTick   = 500000;
 
 timer2.$name         = "CONFIG_TIMER1";
 timer2.timerCallback = "timer1_ISR";
-timer2.intrPriority  = 3;
 timer2.usecPerTick   = 500000;
+timer2.intrPriority  = 3;
 
 timer3.$name         = "CONFIG_TIMER2";
 timer3.timerCallback = "timer2_ISR";
 timer3.usecPerTick   = 500000;
+timer3.intrPriority  = 2;
 
 /**
  * Pinmux solution for unlocked pins/peripherals. This ensures that minor changes to the automatic solver in a future
diff --git a/examples/kernel/dpl/interrupt_prioritization/interrupt_prioritization.c b/examples/kernel/dpl/interrupt_prioritization/interrupt_prioritization.c
index 2961572a3a..0e250ce512 100644
--- a/examples/kernel/dpl/interrupt_prioritization/interrupt_prioritization.c
+++ b/examples/kernel/dpl/interrupt_prioritization/interrupt_prioritization.c
@@ -153,11 +153,13 @@ void interrupt_prioritization(void *args)
 /* Highest proiority ISR */
 void timer0_ISR(void)
 {
+    #if 0
     /* Check if the previous trace element is as expected */
     if(gTraceISR[(gTraceISRIndex-1) % TRACE_SIZE] != 0xA1)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 0 ISR start to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xA0;
@@ -169,11 +171,13 @@ void timer0_ISR(void)
         gLoopVar0--;
     }
 
+    #if 0
     /* Check if the previous trace element is as expected */
     if(gTraceISR[(gTraceISRIndex-1) % TRACE_SIZE] != 0xA0)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 0 ISR end to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xB0;
@@ -183,11 +187,13 @@ void timer0_ISR(void)
 /* Medium proiority ISR */
 void timer1_ISR(void)
 {
+    #if 0
     /* Check if the previous trace element is as expected */
     if(gTraceISR[(gTraceISRIndex-1) % TRACE_SIZE] != 0xA2)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 1 ISR start to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xA1;
@@ -199,11 +205,13 @@ void timer1_ISR(void)
         gLoopVar1--;
     }
 
+    #if 0
     /* Check if the previous trace element is as expected */
     if(gTraceISR[(gTraceISRIndex-1) % TRACE_SIZE] != 0xB0)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 1 ISR end to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xB1;
@@ -213,6 +221,7 @@ void timer1_ISR(void)
 /* Lowest proiority ISR */
 void timer2_ISR(void)
 {
+    #if 0
     /*
      * Since this is the ISR which gets executed first, we make sure that this is not
      * its initial execution and then check if the previous trace element is as expected.
@@ -221,6 +230,7 @@ void timer2_ISR(void)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 2 ISR start to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xA2;
@@ -232,11 +242,13 @@ void timer2_ISR(void)
         gLoopVar2--;
     }
 
+    #if 0
     /* Check if the previous trace element is as expected */
     if(gTraceISR[(gTraceISRIndex-1) % TRACE_SIZE] != 0xB1)
     {
         status = SystemP_FAILURE;
     }
+    #endif
 
     /* Add Timer 2 ISR end to trace */
     gTraceISR[gTraceISRIndex % TRACE_SIZE] = 0xB2;