diff --git a/.project/templates/am243x/enet/board_enet.c.xdt b/.project/templates/am243x/enet/board_enet.c.xdt
index 7b347da7f9..8cee25a997 100644
--- a/.project/templates/am243x/enet/board_enet.c.xdt
+++ b/.project/templates/am243x/enet/board_enet.c.xdt
@@ -80,14 +80,6 @@ static Pinmux_PerCfg_t MDIOPinMuxMainDomainCfg[] = {
 
 #include "ti_drivers_config.h"
 
-#define CONFIG_GPIO0_BASE_ADDR (CSL_GPIO0_BASE)
-#define CONFIG_GPIO0_PIN (70)
-#define CONFIG_GPIO0_DIR (GPIO_DIRECTION_OUTPUT)
-#define CONFIG_GPIO0_TRIG_TYPE (GPIO_TRIG_TYPE_NONE)
-#define CONFIG_GPIO_NUM_INSTANCES (1U)
-
-uint32_t gGpioBaseAddr = CONFIG_GPIO0_BASE_ADDR;
-
 uint32_t txDelay = 500U;
 uint32_t rxDelay = 500U;
 
@@ -105,21 +97,18 @@ uint32_t rxDelay = 2000U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
 
 %if(args.project.board == "am243x-lp") {
-    /* For AM243x-LP board, we need to make GPIO0_70
-       signal high to select signals as CPSW */
-    uint32_t pinNum = CONFIG_GPIO0_PIN;
 
-	/* Address translate */
-	gGpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(gGpioBaseAddr);
+    uint32_t rgmii1PhyRst        = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO26_BASE_ADDR);
+    uint32_t prgCpswRgmii1MuxSel = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO27_BASE_ADDR);
 
-	/* Setup GPIO for CPSW Mux selection */
-	GPIO_setDirMode(gGpioBaseAddr, pinNum, CONFIG_GPIO0_DIR);
-	GPIO_setTrigType(gGpioBaseAddr, pinNum, CONFIG_GPIO0_TRIG_TYPE);
-	GPIO_pinWriteHigh(gGpioBaseAddr, pinNum);
+    GPIO_setDirMode(rgmii1PhyRst, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setDirMode(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_pinWriteHigh(rgmii1PhyRst, CONFIG_GPIO26_PIN);
+    GPIO_pinWriteHigh(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN);
 %}
     return;
 }
diff --git a/examples/networking/enet_layer2_cpsw/am243x-evm/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_cpsw/am243x-evm/r5fss0-0_freertos/board.c
index deca9829e0..33c85feddd 100644
--- a/examples/networking/enet_layer2_cpsw/am243x-evm/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_cpsw/am243x-evm/r5fss0-0_freertos/board.c
@@ -66,8 +66,8 @@ uint32_t rxDelay = 2000U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
 
     return;
 }
diff --git a/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/board.c
index 33963b39a5..1b1e0b404c 100644
--- a/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/board.c
@@ -60,14 +60,6 @@ static Pinmux_PerCfg_t MDIOPinMuxMainDomainCfg[] = {
 
 #include "ti_drivers_config.h"
 
-#define CONFIG_GPIO0_BASE_ADDR (CSL_GPIO0_BASE)
-#define CONFIG_GPIO0_PIN (70)
-#define CONFIG_GPIO0_DIR (GPIO_DIRECTION_OUTPUT)
-#define CONFIG_GPIO0_TRIG_TYPE (GPIO_TRIG_TYPE_NONE)
-#define CONFIG_GPIO_NUM_INSTANCES (1U)
-
-uint32_t gGpioBaseAddr = CONFIG_GPIO0_BASE_ADDR;
-
 uint32_t txDelay = 500U;
 uint32_t rxDelay = 500U;
 
@@ -77,20 +69,30 @@ uint32_t rxDelay = 500U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+
+
+#if 0
 
-    /* For AM243x-LP board, we need to make GPIO0_70
-       signal high to select signals as CPSW */
-    uint32_t pinNum = CONFIG_GPIO0_PIN;
+    /* Address translate */
+    uint32_t gpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO0_BASE_ADDR);
 
-	/* Address translate */
-	gGpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(gGpioBaseAddr);
+    /* Setup GPIO for CPSW Mux selection */
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_TRIG_TYPE);
+    GPIO_pinWriteHigh(gpioBaseAddr, CONFIG_GPIO27_PIN);
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_TRIG_TYPE);
+    GPIO_pinWriteLow(gpioBaseAddr, CONFIG_GPIO26_PIN);
+ #endif
+    uint32_t rgmii1PhyRst        = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO26_BASE_ADDR);
+    uint32_t prgCpswRgmii1MuxSel = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO27_BASE_ADDR);
 
-	/* Setup GPIO for CPSW Mux selection */
-	GPIO_setDirMode(gGpioBaseAddr, pinNum, CONFIG_GPIO0_DIR);
-	GPIO_setTrigType(gGpioBaseAddr, pinNum, CONFIG_GPIO0_TRIG_TYPE);
-	GPIO_pinWriteHigh(gGpioBaseAddr, pinNum);
+    GPIO_setDirMode(rgmii1PhyRst, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setDirMode(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_pinWriteHigh(rgmii1PhyRst, CONFIG_GPIO26_PIN);
+    GPIO_pinWriteHigh(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN);
     return;
 }
 
diff --git a/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg b/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
index d241a038cc..1914cbc356 100644
--- a/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
+++ b/examples/networking/enet_layer2_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
@@ -2,7 +2,7 @@
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
  * @cliArgs --device "AM243x_ALX_beta" --package "ALX" --part "ALX" --context "r5fss0-0" --product "MCU_PLUS_SDK@07.03.01"
- * @versions {"tool":"1.10.0+2163"}
+ * @versions {"tool":"1.12.1+2446"}
  */
 
 /**
@@ -10,6 +10,7 @@
  */
 const gpio       = scripting.addModule("/drivers/gpio/gpio", {}, false);
 const gpio1      = gpio.addInstance();
+const gpio2      = gpio.addInstance();
 const pruicss    = scripting.addModule("/drivers/pruicss/pruicss", {}, false);
 const pruicss1   = pruicss.addInstance();
 const udma       = scripting.addModule("/drivers/udma/udma", {}, false);
@@ -28,9 +29,15 @@ const enet_cpsw1 = enet_cpsw.addInstance();
 /**
  * Write custom configuration values to the imported modules.
  */
-gpio1.$name                = "CONFIG_GPIO0";
+gpio1.$name                = "CONFIG_GPIO26";
 gpio1.pinDir               = "OUTPUT";
-gpio1.GPIO.gpioPin.$assign = "ball.AA11";
+gpio1.GPIO.gpioPin.pu_pd   = "pu";
+gpio1.GPIO.gpioPin.$assign = "ball.W20";
+
+gpio2.$name                = "CONFIG_GPIO27";
+gpio2.pinDir               = "OUTPUT";
+gpio2.GPIO.gpioPin.pu_pd   = "pu";
+gpio2.GPIO.gpioPin.$assign = "ball.Y20";
 
 pruicss1.$name = "CONFIG_PRU_ICSS0";
 
@@ -98,5 +105,6 @@ enet_cpsw1.RGMII.TXC.$assign     = "ball.W13";
  * re-solve from scratch.
  */
 gpio1.GPIO.$suggestSolution                 = "GPIO0";
+gpio2.GPIO.$suggestSolution                 = "GPIO0";
 debug_log.uartLog.UART.RXD.$suggestSolution = "ball.B10";
 debug_log.uartLog.UART.TXD.$suggestSolution = "ball.B11";
diff --git a/examples/networking/enet_layer2_cpsw_switch/am243x-evm/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_cpsw_switch/am243x-evm/r5fss0-0_freertos/board.c
index deca9829e0..33c85feddd 100644
--- a/examples/networking/enet_layer2_cpsw_switch/am243x-evm/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_cpsw_switch/am243x-evm/r5fss0-0_freertos/board.c
@@ -66,8 +66,8 @@ uint32_t rxDelay = 2000U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
 
     return;
 }
diff --git a/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/board.c
index 33963b39a5..1b1e0b404c 100644
--- a/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/board.c
@@ -60,14 +60,6 @@ static Pinmux_PerCfg_t MDIOPinMuxMainDomainCfg[] = {
 
 #include "ti_drivers_config.h"
 
-#define CONFIG_GPIO0_BASE_ADDR (CSL_GPIO0_BASE)
-#define CONFIG_GPIO0_PIN (70)
-#define CONFIG_GPIO0_DIR (GPIO_DIRECTION_OUTPUT)
-#define CONFIG_GPIO0_TRIG_TYPE (GPIO_TRIG_TYPE_NONE)
-#define CONFIG_GPIO_NUM_INSTANCES (1U)
-
-uint32_t gGpioBaseAddr = CONFIG_GPIO0_BASE_ADDR;
-
 uint32_t txDelay = 500U;
 uint32_t rxDelay = 500U;
 
@@ -77,20 +69,30 @@ uint32_t rxDelay = 500U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+
+
+#if 0
 
-    /* For AM243x-LP board, we need to make GPIO0_70
-       signal high to select signals as CPSW */
-    uint32_t pinNum = CONFIG_GPIO0_PIN;
+    /* Address translate */
+    uint32_t gpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO0_BASE_ADDR);
 
-	/* Address translate */
-	gGpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(gGpioBaseAddr);
+    /* Setup GPIO for CPSW Mux selection */
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_TRIG_TYPE);
+    GPIO_pinWriteHigh(gpioBaseAddr, CONFIG_GPIO27_PIN);
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_TRIG_TYPE);
+    GPIO_pinWriteLow(gpioBaseAddr, CONFIG_GPIO26_PIN);
+ #endif
+    uint32_t rgmii1PhyRst        = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO26_BASE_ADDR);
+    uint32_t prgCpswRgmii1MuxSel = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO27_BASE_ADDR);
 
-	/* Setup GPIO for CPSW Mux selection */
-	GPIO_setDirMode(gGpioBaseAddr, pinNum, CONFIG_GPIO0_DIR);
-	GPIO_setTrigType(gGpioBaseAddr, pinNum, CONFIG_GPIO0_TRIG_TYPE);
-	GPIO_pinWriteHigh(gGpioBaseAddr, pinNum);
+    GPIO_setDirMode(rgmii1PhyRst, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setDirMode(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_pinWriteHigh(rgmii1PhyRst, CONFIG_GPIO26_PIN);
+    GPIO_pinWriteHigh(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN);
     return;
 }
 
diff --git a/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/example.syscfg b/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/example.syscfg
index 58e53e29d8..bd9ca4b58b 100644
--- a/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/example.syscfg
+++ b/examples/networking/enet_layer2_cpsw_switch/am243x-lp/r5fss0-0_freertos/example.syscfg
@@ -2,7 +2,7 @@
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
  * @cliArgs --device "AM243x_ALX_beta" --package "ALX" --part "ALX" --context "r5fss0-0" --product "MCU_PLUS_SDK@07.03.01"
- * @versions {"tool":"1.10.0+2163"}
+ * @versions {"tool":"1.12.1+2446"}
  */
 
 /**
@@ -10,6 +10,7 @@
  */
 const gpio       = scripting.addModule("/drivers/gpio/gpio", {}, false);
 const gpio1      = gpio.addInstance();
+const gpio2      = gpio.addInstance();
 const pruicss    = scripting.addModule("/drivers/pruicss/pruicss", {}, false);
 const pruicss1   = pruicss.addInstance();
 const udma       = scripting.addModule("/drivers/udma/udma", {}, false);
@@ -29,9 +30,15 @@ const enet_cpsw2 = enet_cpsw.addInstance();
 /**
  * Write custom configuration values to the imported modules.
  */
-gpio1.$name                = "CONFIG_GPIO0";
+gpio1.$name                = "CONFIG_GPIO26";
 gpio1.pinDir               = "OUTPUT";
-gpio1.GPIO.gpioPin.$assign = "ball.AA11";
+gpio1.GPIO.gpioPin.pu_pd   = "pu";
+gpio1.GPIO.gpioPin.$assign = "ball.W20";
+
+gpio2.$name                = "CONFIG_GPIO27";
+gpio2.pinDir               = "OUTPUT";
+gpio2.GPIO.gpioPin.pu_pd   = "pu";
+gpio2.GPIO.gpioPin.$assign = "ball.Y20";
 
 pruicss1.$name = "CONFIG_PRU_ICSS0";
 
@@ -102,6 +109,7 @@ enet_cpsw2.phyToMacInterfaceMode = "RGMII";
  * re-solve from scratch.
  */
 gpio1.GPIO.$suggestSolution                 = "GPIO0";
+gpio2.GPIO.$suggestSolution                 = "GPIO0";
 debug_log.uartLog.UART.RXD.$suggestSolution = "ball.B10";
 debug_log.uartLog.UART.TXD.$suggestSolution = "ball.B11";
 enet_cpsw2.RGMII.$suggestSolution           = "RGMII2";
diff --git a/examples/networking/enet_layer2_multi_channel/am243x-evm/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_multi_channel/am243x-evm/r5fss0-0_freertos/board.c
index deca9829e0..33c85feddd 100644
--- a/examples/networking/enet_layer2_multi_channel/am243x-evm/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_multi_channel/am243x-evm/r5fss0-0_freertos/board.c
@@ -66,8 +66,8 @@ uint32_t rxDelay = 2000U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
 
     return;
 }
diff --git a/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/board.c b/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/board.c
index 33963b39a5..1b1e0b404c 100644
--- a/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/board.c
+++ b/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/board.c
@@ -60,14 +60,6 @@ static Pinmux_PerCfg_t MDIOPinMuxMainDomainCfg[] = {
 
 #include "ti_drivers_config.h"
 
-#define CONFIG_GPIO0_BASE_ADDR (CSL_GPIO0_BASE)
-#define CONFIG_GPIO0_PIN (70)
-#define CONFIG_GPIO0_DIR (GPIO_DIRECTION_OUTPUT)
-#define CONFIG_GPIO0_TRIG_TYPE (GPIO_TRIG_TYPE_NONE)
-#define CONFIG_GPIO_NUM_INSTANCES (1U)
-
-uint32_t gGpioBaseAddr = CONFIG_GPIO0_BASE_ADDR;
-
 uint32_t txDelay = 500U;
 uint32_t rxDelay = 500U;
 
@@ -77,20 +69,30 @@ uint32_t rxDelay = 500U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+
+
+#if 0
 
-    /* For AM243x-LP board, we need to make GPIO0_70
-       signal high to select signals as CPSW */
-    uint32_t pinNum = CONFIG_GPIO0_PIN;
+    /* Address translate */
+    uint32_t gpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO0_BASE_ADDR);
 
-	/* Address translate */
-	gGpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(gGpioBaseAddr);
+    /* Setup GPIO for CPSW Mux selection */
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_TRIG_TYPE);
+    GPIO_pinWriteHigh(gpioBaseAddr, CONFIG_GPIO27_PIN);
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_TRIG_TYPE);
+    GPIO_pinWriteLow(gpioBaseAddr, CONFIG_GPIO26_PIN);
+ #endif
+    uint32_t rgmii1PhyRst        = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO26_BASE_ADDR);
+    uint32_t prgCpswRgmii1MuxSel = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO27_BASE_ADDR);
 
-	/* Setup GPIO for CPSW Mux selection */
-	GPIO_setDirMode(gGpioBaseAddr, pinNum, CONFIG_GPIO0_DIR);
-	GPIO_setTrigType(gGpioBaseAddr, pinNum, CONFIG_GPIO0_TRIG_TYPE);
-	GPIO_pinWriteHigh(gGpioBaseAddr, pinNum);
+    GPIO_setDirMode(rgmii1PhyRst, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setDirMode(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_pinWriteHigh(rgmii1PhyRst, CONFIG_GPIO26_PIN);
+    GPIO_pinWriteHigh(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN);
     return;
 }
 
diff --git a/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/example.syscfg b/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/example.syscfg
index d241a038cc..1914cbc356 100644
--- a/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/example.syscfg
+++ b/examples/networking/enet_layer2_multi_channel/am243x-lp/r5fss0-0_freertos/example.syscfg
@@ -2,7 +2,7 @@
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
  * @cliArgs --device "AM243x_ALX_beta" --package "ALX" --part "ALX" --context "r5fss0-0" --product "MCU_PLUS_SDK@07.03.01"
- * @versions {"tool":"1.10.0+2163"}
+ * @versions {"tool":"1.12.1+2446"}
  */
 
 /**
@@ -10,6 +10,7 @@
  */
 const gpio       = scripting.addModule("/drivers/gpio/gpio", {}, false);
 const gpio1      = gpio.addInstance();
+const gpio2      = gpio.addInstance();
 const pruicss    = scripting.addModule("/drivers/pruicss/pruicss", {}, false);
 const pruicss1   = pruicss.addInstance();
 const udma       = scripting.addModule("/drivers/udma/udma", {}, false);
@@ -28,9 +29,15 @@ const enet_cpsw1 = enet_cpsw.addInstance();
 /**
  * Write custom configuration values to the imported modules.
  */
-gpio1.$name                = "CONFIG_GPIO0";
+gpio1.$name                = "CONFIG_GPIO26";
 gpio1.pinDir               = "OUTPUT";
-gpio1.GPIO.gpioPin.$assign = "ball.AA11";
+gpio1.GPIO.gpioPin.pu_pd   = "pu";
+gpio1.GPIO.gpioPin.$assign = "ball.W20";
+
+gpio2.$name                = "CONFIG_GPIO27";
+gpio2.pinDir               = "OUTPUT";
+gpio2.GPIO.gpioPin.pu_pd   = "pu";
+gpio2.GPIO.gpioPin.$assign = "ball.Y20";
 
 pruicss1.$name = "CONFIG_PRU_ICSS0";
 
@@ -98,5 +105,6 @@ enet_cpsw1.RGMII.TXC.$assign     = "ball.W13";
  * re-solve from scratch.
  */
 gpio1.GPIO.$suggestSolution                 = "GPIO0";
+gpio2.GPIO.$suggestSolution                 = "GPIO0";
 debug_log.uartLog.UART.RXD.$suggestSolution = "ball.B10";
 debug_log.uartLog.UART.TXD.$suggestSolution = "ball.B11";
diff --git a/examples/networking/lwip/enet_lwip_cpsw/am243x-evm/r5fss0-0_freertos/board.c b/examples/networking/lwip/enet_lwip_cpsw/am243x-evm/r5fss0-0_freertos/board.c
index deca9829e0..33c85feddd 100644
--- a/examples/networking/lwip/enet_lwip_cpsw/am243x-evm/r5fss0-0_freertos/board.c
+++ b/examples/networking/lwip/enet_lwip_cpsw/am243x-evm/r5fss0-0_freertos/board.c
@@ -66,8 +66,8 @@ uint32_t rxDelay = 2000U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
 
     return;
 }
diff --git a/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/board.c b/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/board.c
index 33963b39a5..1b1e0b404c 100644
--- a/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/board.c
+++ b/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/board.c
@@ -60,14 +60,6 @@ static Pinmux_PerCfg_t MDIOPinMuxMainDomainCfg[] = {
 
 #include "ti_drivers_config.h"
 
-#define CONFIG_GPIO0_BASE_ADDR (CSL_GPIO0_BASE)
-#define CONFIG_GPIO0_PIN (70)
-#define CONFIG_GPIO0_DIR (GPIO_DIRECTION_OUTPUT)
-#define CONFIG_GPIO0_TRIG_TYPE (GPIO_TRIG_TYPE_NONE)
-#define CONFIG_GPIO_NUM_INSTANCES (1U)
-
-uint32_t gGpioBaseAddr = CONFIG_GPIO0_BASE_ADDR;
-
 uint32_t txDelay = 500U;
 uint32_t rxDelay = 500U;
 
@@ -77,20 +69,30 @@ uint32_t rxDelay = 500U;
  */
 void Board_cpswMuxSel(void)
 {
-	/* MDIO0 pin config */
-	Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+    /* MDIO0 pin config */
+    Pinmux_config(MDIOPinMuxMainDomainCfg, PINMUX_DOMAIN_ID_MAIN);
+
+
+#if 0
 
-    /* For AM243x-LP board, we need to make GPIO0_70
-       signal high to select signals as CPSW */
-    uint32_t pinNum = CONFIG_GPIO0_PIN;
+    /* Address translate */
+    uint32_t gpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO0_BASE_ADDR);
 
-	/* Address translate */
-	gGpioBaseAddr = (uint32_t) AddrTranslateP_getLocalAddr(gGpioBaseAddr);
+    /* Setup GPIO for CPSW Mux selection */
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO27_PIN, CONFIG_GPIO27_TRIG_TYPE);
+    GPIO_pinWriteHigh(gpioBaseAddr, CONFIG_GPIO27_PIN);
+    GPIO_setDirMode(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setTrigType(gpioBaseAddr, CONFIG_GPIO26_PIN, CONFIG_GPIO26_TRIG_TYPE);
+    GPIO_pinWriteLow(gpioBaseAddr, CONFIG_GPIO26_PIN);
+ #endif
+    uint32_t rgmii1PhyRst        = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO26_BASE_ADDR);
+    uint32_t prgCpswRgmii1MuxSel = (uint32_t) AddrTranslateP_getLocalAddr(CONFIG_GPIO27_BASE_ADDR);
 
-	/* Setup GPIO for CPSW Mux selection */
-	GPIO_setDirMode(gGpioBaseAddr, pinNum, CONFIG_GPIO0_DIR);
-	GPIO_setTrigType(gGpioBaseAddr, pinNum, CONFIG_GPIO0_TRIG_TYPE);
-	GPIO_pinWriteHigh(gGpioBaseAddr, pinNum);
+    GPIO_setDirMode(rgmii1PhyRst, CONFIG_GPIO26_PIN, CONFIG_GPIO26_DIR);
+    GPIO_setDirMode(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN, CONFIG_GPIO27_DIR);
+    GPIO_pinWriteHigh(rgmii1PhyRst, CONFIG_GPIO26_PIN);
+    GPIO_pinWriteHigh(prgCpswRgmii1MuxSel, CONFIG_GPIO27_PIN);
     return;
 }
 
diff --git a/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg b/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
index d458140f07..f0afc80bb2 100644
--- a/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
+++ b/examples/networking/lwip/enet_lwip_cpsw/am243x-lp/r5fss0-0_freertos/example.syscfg
@@ -2,7 +2,7 @@
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
  * @cliArgs --device "AM243x_ALX_beta" --package "ALX" --part "ALX" --context "r5fss0-0" --product "MCU_PLUS_SDK@07.03.01"
- * @versions {"tool":"1.12.0+2406"}
+ * @versions {"tool":"1.12.1+2446"}
  */
 
 /**
@@ -10,6 +10,7 @@
  */
 const gpio       = scripting.addModule("/drivers/gpio/gpio", {}, false);
 const gpio1      = gpio.addInstance();
+const gpio2      = gpio.addInstance();
 const pruicss    = scripting.addModule("/drivers/pruicss/pruicss", {}, false);
 const pruicss1   = pruicss.addInstance();
 const udma       = scripting.addModule("/drivers/udma/udma", {}, false);
@@ -28,9 +29,15 @@ const enet_cpsw1 = enet_cpsw.addInstance();
 /**
  * Write custom configuration values to the imported modules.
  */
-gpio1.$name                = "CONFIG_GPIO0";
+gpio1.$name                = "CONFIG_GPIO26";
 gpio1.pinDir               = "OUTPUT";
-gpio1.GPIO.gpioPin.$assign = "ball.AA11";
+gpio1.GPIO.gpioPin.pu_pd   = "pu";
+gpio1.GPIO.gpioPin.$assign = "ball.W20";
+
+gpio2.$name                = "CONFIG_GPIO27";
+gpio2.pinDir               = "OUTPUT";
+gpio2.GPIO.gpioPin.pu_pd   = "pu";
+gpio2.GPIO.gpioPin.$assign = "ball.Y20";
 
 pruicss1.$name = "CONFIG_PRU_ICSS0";
 
@@ -99,5 +106,6 @@ enet_cpsw1.RGMII.TXC.$assign     = "ball.W13";
  * re-solve from scratch.
  */
 gpio1.GPIO.$suggestSolution                 = "GPIO0";
+gpio2.GPIO.$suggestSolution                 = "GPIO0";
 debug_log.uartLog.UART.RXD.$suggestSolution = "ball.B10";
 debug_log.uartLog.UART.TXD.$suggestSolution = "ball.B11";